function [ GlobK, GlobM ] = GlobalStiffnessAsm_Truss(nels, nnds, elems, nodes,...
                     dofPerNode)
%UNTITLED      
%            .
% Copyright 2017 Daniil S. Denisov
%         .
%   .
systemDOF = nnds*dofPerNode;
GlobK = zeros(systemDOF,systemDOF);
GlobM = zeros(systemDOF,systemDOF);

%   .
for i=1:nels
    %      .
    currElem = elems(i,:);
    currNode1 = nodes(currElem(1),:);
    currNode2 = nodes(currElem(2),:);
    currArea = currElem(3);
    currEmod = currElem(4);
    currRho = 7800;
    
    %     .
    [tElem, elength, ~, ~] = ElemTransformCalc(currNode1,currNode2);
    %      .
    kInit = zeros(4,4);
    k = currArea*currEmod/elength;
    kInit(1,1) = k;
    kInit(1,3) = -k;
    kInit(3,1) = -k;
    kInit(3,3) = k;
    % .   .
    ke = tElem'*kInit*tElem;
    
    %    .
    meInit = (currRho*currArea*elength/6)*...
        [2 0 1 0; 0 2 0 1; 1 0 2 0; 0 1 0 2];
    me = tElem'*meInit*tElem;
    
    %      . .
    %      .
    glDOF1 = (currElem(1)-1)*dofPerNode+1;
    glDOF2 = glDOF1+1;
    glDOF3 = (currElem(2)-1)*dofPerNode+1;
    glDOF4 = glDOF3+1;
    %   ke  .  GlobK.
    GlobK(glDOF1,glDOF1) = GlobK(glDOF1,glDOF1) + ke(1,1);
    GlobK(glDOF1,glDOF2) = GlobK(glDOF1,glDOF2) + ke(1,2);
    GlobK(glDOF1,glDOF3) = GlobK(glDOF1,glDOF3) + ke(1,3);
    GlobK(glDOF1,glDOF4) = GlobK(glDOF1,glDOF4) + ke(1,4);
    GlobK(glDOF2,glDOF1) = GlobK(glDOF2,glDOF1) + ke(2,1);
    GlobK(glDOF2,glDOF2) = GlobK(glDOF2,glDOF2) + ke(2,2);
    GlobK(glDOF2,glDOF3) = GlobK(glDOF2,glDOF3) + ke(2,3);
    GlobK(glDOF2,glDOF4) = GlobK(glDOF2,glDOF4) + ke(2,4);
    GlobK(glDOF3,glDOF1) = GlobK(glDOF3,glDOF1) + ke(3,1);
    GlobK(glDOF3,glDOF2) = GlobK(glDOF3,glDOF2) + ke(3,2);
    GlobK(glDOF3,glDOF3) = GlobK(glDOF3,glDOF3) + ke(3,3);
    GlobK(glDOF3,glDOF4) = GlobK(glDOF3,glDOF4) + ke(3,4);
    GlobK(glDOF4,glDOF1) = GlobK(glDOF4,glDOF1) + ke(4,1);
    GlobK(glDOF4,glDOF2) = GlobK(glDOF4,glDOF2) + ke(4,2);
    GlobK(glDOF4,glDOF3) = GlobK(glDOF4,glDOF3) + ke(4,3);
    GlobK(glDOF4,glDOF4) = GlobK(glDOF4,glDOF4) + ke(4,4);
    
    %      GlobM.
    GlobM(glDOF1,glDOF1) = GlobM(glDOF1,glDOF1) + me(1,1);
    GlobM(glDOF1,glDOF2) = GlobM(glDOF1,glDOF2) + me(1,2);
    GlobM(glDOF1,glDOF3) = GlobM(glDOF1,glDOF3) + me(1,3);
    GlobM(glDOF1,glDOF4) = GlobM(glDOF1,glDOF4) + me(1,4);
    GlobM(glDOF2,glDOF1) = GlobM(glDOF2,glDOF1) + me(2,1);
    GlobM(glDOF2,glDOF2) = GlobM(glDOF2,glDOF2) + me(2,2);
    GlobM(glDOF2,glDOF3) = GlobM(glDOF2,glDOF3) + me(2,3);
    GlobM(glDOF2,glDOF4) = GlobM(glDOF2,glDOF4) + me(2,4);
    GlobM(glDOF3,glDOF1) = GlobM(glDOF3,glDOF1) + me(3,1);
    GlobM(glDOF3,glDOF2) = GlobM(glDOF3,glDOF2) + me(3,2);
    GlobM(glDOF3,glDOF3) = GlobM(glDOF3,glDOF3) + me(3,3);
    GlobM(glDOF3,glDOF4) = GlobM(glDOF3,glDOF4) + me(3,4);
    GlobM(glDOF4,glDOF1) = GlobM(glDOF4,glDOF1) + me(4,1);
    GlobM(glDOF4,glDOF2) = GlobM(glDOF4,glDOF2) + me(4,2);
    GlobM(glDOF4,glDOF3) = GlobM(glDOF4,glDOF3) + me(4,3);
    GlobM(glDOF4,glDOF4) = GlobM(glDOF4,glDOF4) + me(4,4);
end
end