function [dspl] = RunTrussFEA(caseFileName)
% Copyright 2017 Daniil S. Denisov
%  .
[ nNodes,nElems,nBCs,allElems,allNodes,allBCs ] = ...
    ReadMesh( caseFileName );
%    ,   .
fprintf('Case: [%d Nodes], [%d Elements], [%d BConds]\n',...
    nNodes,nElems,nBCs);
%  .     .
PlotMesh(nNodes,nElems,nBCs,allElems,allNodes,allBCs);
%    .
dofPerNode = 2;
%        .
[GlobK, GlobM] = GlobalStiffnessAsm_Truss(nElems, nNodes,...
    allElems, allNodes, dofPerNode);
%    ().
GlobF = zeros(nNodes*dofPerNode,1);
%  .
[GlobKBC, GlobFBC] = ApplyBC(GlobK, GlobF, allBCs, dofPerNode);
%  ,  . .
dspl = GlobKBC\GlobFBC;
disp('DOFs (displ. components):')
disp(dspl);
%  . .
reacts = GlobK*dspl-GlobFBC;
disp('Reactions (components):')
disp(reacts);
%  . .
sigma = StressCalc( nElems, allElems, allNodes, dspl, dofPerNode);
disp('Stress per elem:')
disp(sigma);

%     .
%       .
[GlobKBCEig, GlobMBCEig] = ApplyBCEig(GlobK, GlobM, allBCs, dofPerNode);
freqSol = (1/(2*pi))*sqrt(eig(GlobKBCEig, GlobMBCEig));
disp('Natural frequencies (Hz):')
disp(freqSol);
end